#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

static float result(void);
static void f(int, float *, float *, int, int);

int
main(void)
{
	float *v1 = NULL, *v2 = NULL, in1, in2;
	size_t sz = 0;

	while (2 == scanf("%f,%f", &in1, &in2)) {
		v1 = realloc(v1, (sz + 1) * sizeof(float));
		v2 = realloc(v2, (sz + 1) * sizeof(float));
		v1[sz] = in1;
		v2[sz++] = in2;
	}

	if (0 == fork())
		f(0, v1, v2, 0, sz / 2);
	if (0 == fork())
		f(1, v1, v2, sz / 2, sz);

	wait(NULL); wait(NULL);
	printf("%g\n", result());
	free(v1); free(v2);
	return(EXIT_SUCCESS);
}

static float
result(void)
{
	FILE *f;
	float in1, in2;

	f = fopen("example3.0.dat", "r");
	fscanf(f, "%f", &in1);
	fclose(f);

	f = fopen("example3.1.dat", "r");
	fscanf(f, "%f", &in2);
	fclose(f);

	return(in1 + in2);
}

static void
f(int id, float *v1, float *v2, int start, int sz)
{
	FILE *f;
	char buf[64];
	int i;
	float res;

	for (res = 0.0, i = start; i < sz; i++)
		res += v1[i] * v2[i];

	snprintf(buf, sizeof(buf), "example3.%d.dat", id);
	f = fopen(buf, "w");
	fprintf(f, "%g\n", res);
	fclose(f);

	free(v1);
	free(v2);
	exit(EXIT_SUCCESS);
}
